Index: binaries/data/mods/public/simulation/components/ResourceGatherer.js
===================================================================
--- binaries/data/mods/public/simulation/components/ResourceGatherer.js	(revision 15170)
+++ binaries/data/mods/public/simulation/components/ResourceGatherer.js	(working copy)
@@ -341,3 +341,805 @@
 };
 
 Engine.RegisterComponentType(IID_ResourceGatherer, "ResourceGatherer", ResourceGatherer);
+
+
+// UNIT AI COMMANDS
+
+UnitAI.prototype.UnitFsmSpec["Order.Gather"] = function(msg)
+{
+	// If the target is still alive, we need to kill it first
+	if (this.MustKillGatherTarget(this.order.data.target))
+	{
+		// Make sure we can attack the target, else we'll get very stuck
+		if (!this.GetBestAttackAgainst(this.order.data.target))
+		{
+			// Oops, we can't attack at all - give up
+			// TODO: should do something so the player knows why this failed
+			this.FinishOrder();
+			return;
+		}
+		// The target was visible when this order was issued,
+		// but could now be invisible again.
+		if (!this.CheckTargetVisible(this.order.data.target))
+		{
+			if (this.order.data.secondTry === undefined)
+			{
+				this.order.data.secondTry = true;
+				this.PushOrderFront("Walk", this.order.data.lastPos);
+			}
+			else
+			{
+				// We couldn't move there, or the target moved away
+				this.FinishOrder();
+			}
+			return;
+		}
+
+		this.PushOrderFront("Attack", { "target": this.order.data.target, "force": false, "hunting": true });
+		return;
+	}
+	// Try to move within range
+	if (this.MoveToTargetRange(this.order.data.target, IID_ResourceGatherer))
+	{
+		// We've started walking to the given point
+		this.SetNextState("INDIVIDUAL.GATHER.APPROACHING");
+	}
+	else
+	{
+		// We are already at the target, or can't move at all,
+		// so try gathering it from here.
+		// TODO: need better handling of the can't-reach-target case
+		this.StopMoving();
+		this.SetNextStateAlwaysEntering("INDIVIDUAL.GATHER.GATHERING");
+	}
+};
+
+UnitAI.prototype.UnitFsmSpec["Order.GatherNearPosition"] = function(msg)
+{
+	// Move the unit to the position to gather from.
+	this.MoveToPoint(this.order.data.x, this.order.data.z);
+	this.SetNextState("INDIVIDUAL.GATHER.WALKING");
+};
+
+UnitAI.prototype.UnitFsmSpec["Order.ReturnResource"] = function(msg)
+{
+	// Check if the dropsite is already in range
+	if (this.CheckTargetRange(this.order.data.target, IID_ResourceGatherer) && this.CanReturnResource(this.order.data.target, true))
+	{
+		var cmpResourceDropsite = Engine.QueryInterface(this.order.data.target, IID_ResourceDropsite);
+		if (cmpResourceDropsite)
+		{
+			// Dump any resources we can
+			var dropsiteTypes = cmpResourceDropsite.GetTypes();
+
+			Engine.QueryInterface(this.entity, IID_ResourceGatherer).CommitResources(dropsiteTypes);
+
+			// Our next order should always be a Gather,
+			// so just switch back to that order
+			this.FinishOrder();
+			return;
+		}
+	}
+	// Try to move to the dropsite
+	if (this.MoveToTargetRange(this.order.data.target, IID_ResourceGatherer))
+	{
+		// We've started walking to the target
+		this.SetNextState("INDIVIDUAL.RETURNRESOURCE.APPROACHING");
+		return;
+	}
+	// Oops, we can't reach the dropsite.
+	// Maybe we should try to pick another dropsite, to find an
+	// accessible one?
+	// For now, just give up.
+	this.StopMoving();
+	this.FinishOrder();
+	return;
+};
+
+UnitAI.prototype.UnitFsmSpec.FORMATIONCONTROLLER["Order.Gather"] = function(msg)
+{
+	if (this.MustKillGatherTarget(msg.data.target))
+	{
+		// The target was visible when this order was given,
+		// but could now be invisible.
+		if (!this.CheckTargetVisible(msg.data.target))
+		{
+			if (msg.data.secondTry === undefined)
+			{
+				msg.data.secondTry = true;
+				this.PushOrderFront("Walk", msg.data.lastPos);
+			}
+			else
+			{
+				// We couldn't move there, or the target moved away
+				this.FinishOrder();
+			}
+			return;
+		}
+
+		this.PushOrderFront("Attack", { "target": msg.data.target, "hunting": true });
+		return;
+	}
+
+	// TODO: on what should we base this range?
+	// Check if we are already in range, otherwise walk there
+	if (!this.CheckTargetRangeExplicit(msg.data.target, 0, 10))
+	{
+		if (!this.CanGather(msg.data.target) || !this.CheckTargetVisible(msg.data.target))
+			// The target isn't gatherable or not visible any more.
+			this.FinishOrder();
+		// TODO: Should we issue a gather-near-position order
+		// if the target isn't gatherable/doesn't exist anymore?
+		else
+			// Out of range; move there in formation
+			this.PushOrderFront("WalkToTargetRange", { "target": msg.data.target, "min": 0, "max": 10 });
+		return;
+	}
+
+	this.CallMemberFunction("Gather", [msg.data.target, false]);
+
+	this.SetNextStateAlwaysEntering("MEMBER");
+};
+
+UnitAI.prototype.UnitFsmSpec.FORMATIONCONTROLLER["Order.GatherNearPosition"] = function(msg)
+{
+	// TODO: on what should we base this range?
+	// Check if we are already in range, otherwise walk there
+	if (!this.CheckPointRangeExplicit(msg.data.x, msg.data.z, 0, 20))
+	{
+		// Out of range; move there in formation
+		this.PushOrderFront("WalkToPointRange", { "x": msg.data.x, "z": msg.data.z, "min": 0, "max": 20 });
+		return;
+	}
+
+	this.CallMemberFunction("GatherNearPosition", [msg.data.x, msg.data.z, msg.data.type, msg.data.template, false]);
+
+	this.SetNextStateAlwaysEntering("MEMBER");
+};
+
+UnitAI.prototype.UnitFsmSpec.FORMATIONCONTROLLER["Order.ReturnResource"] = function(msg)
+{
+	// TODO: on what should we base this range?
+	// Check if we are already in range, otherwise walk there
+	if (!this.CheckTargetRangeExplicit(msg.data.target, 0, 10))
+	{
+		if (!this.TargetIsAlive(msg.data.target) || !this.CheckTargetVisible(msg.data.target))
+			// The target was destroyed
+			this.FinishOrder();
+		else
+			// Out of range; move there in formation
+			this.PushOrderFront("WalkToTargetRange", { "target": msg.data.target, "min": 0, "max": 10 });
+		return;
+	}
+
+	this.CallMemberFunction("ReturnResource", [msg.data.target, false]);
+
+	this.SetNextStateAlwaysEntering("MEMBER");
+};
+
+UnitAI.prototype.UnitFsmSpec.INDIVIDUAL.GATHER = {
+	"APPROACHING": {
+		"enter": function() {
+			this.SelectAnimation("move");
+
+			this.gatheringTarget = this.order.data.target;	// temporary, deleted in "leave".
+
+			// check that we can gather from the resource we're supposed to gather from.
+			var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+			var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+			if (!cmpSupply || !cmpSupply.AddGatherer(cmpOwnership.GetOwner(), this.entity))
+			{
+				// Save the current order's data in case we need it later
+				var oldType = this.order.data.type;
+				var oldTarget = this.order.data.target;
+				var oldTemplate = this.order.data.template;
+
+				// Try the next queued order if there is any
+				if (this.FinishOrder())
+					return true;
+				
+				// Try to find another nearby target of the same specific type
+				// Also don't switch to a different type of huntable animal
+				var nearby = this.FindNearbyResource(function (ent, type, template) {
+					return (
+						ent != oldTarget
+						 && ((type.generic == "treasure" && oldType.generic == "treasure")
+						 || (type.specific == oldType.specific
+						 && (type.specific != "meat" || oldTemplate == template)))
+					);
+				});
+				if (nearby)
+				{
+					this.PerformGather(nearby, false, false);
+					return true;
+				}
+				else
+				{
+					// It's probably better in this case, to avoid units getting stuck around a dropsite
+					// in a "Target is far away, full, nearby are no good resources, return to dropsite" loop
+					// to order it to GatherNear the resource position.
+					var cmpPosition = Engine.QueryInterface(this.gatheringTarget, IID_Position);
+					if (cmpPosition)
+					{
+						var pos = cmpPosition.GetPosition();
+						this.GatherNearPosition(pos.x, pos.z, oldType, oldTemplate);
+						return true;
+					} else {
+						// we're kind of stuck here. Return resource.
+						var nearby = this.FindNearestDropsite(oldType.generic);
+						if (nearby)
+						{
+							this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
+							return true;
+						}
+					}
+				}
+				return true;
+			}
+			return false;
+		},
+
+		"MoveCompleted": function(msg) {
+			if (msg.data.error)
+			{
+				// We failed to reach the target
+
+				// remove us from the list of entities gathering from Resource.
+				var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+				var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+				if (cmpSupply && cmpOwnership)
+					cmpSupply.RemoveGatherer(this.entity, cmpOwnership.GetOwner());
+				else if (cmpSupply)
+					cmpSupply.RemoveGatherer(this.entity);
+
+				// Save the current order's data in case we need it later
+				var oldType = this.order.data.type;
+				var oldTarget = this.order.data.target;
+				var oldTemplate = this.order.data.template;
+
+				// Try the next queued order if there is any
+				if (this.FinishOrder())
+					return;
+
+				// Try to find another nearby target of the same specific type
+				// Also don't switch to a different type of huntable animal
+				var nearby = this.FindNearbyResource(function (ent, type, template) {
+					return (
+						ent != oldTarget
+						&& ((type.generic == "treasure" && oldType.generic == "treasure")
+						|| (type.specific == oldType.specific
+						&& (type.specific != "meat" || oldTemplate == template)))
+					);
+				});
+				if (nearby)
+				{
+					this.PerformGather(nearby, false, false);
+					return;
+				}
+
+				// Couldn't find anything else. Just try this one again,
+				// maybe we'll succeed next time
+				this.PerformGather(oldTarget, false, false);
+				return;
+			}
+
+			// We reached the target - start gathering from it now
+			this.SetNextState("GATHERING");
+		},
+		
+		"leave": function() {
+			// don't use ownership because this is called after a conversion/resignation
+			// and the ownership would be invalid then.
+			var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+			if (cmpSupply)
+				cmpSupply.RemoveGatherer(this.entity);
+			delete this.gatheringTarget;
+		},
+	},
+	
+	// Walking to a good place to gather resources near, used by GatherNearPosition
+	"WALKING": {
+		"enter": function() {
+			this.SelectAnimation("move");
+		},
+
+		"MoveCompleted": function(msg) {
+			var resourceType = this.order.data.type;
+			var resourceTemplate = this.order.data.template;
+
+			// Try to find another nearby target of the same specific type
+			// Also don't switch to a different type of huntable animal
+			var nearby = this.FindNearbyResource(function (ent, type, template) {
+				return (
+					(type.generic == "treasure" && resourceType.generic == "treasure")
+					|| (type.specific == resourceType.specific
+					&& (type.specific != "meat" || resourceTemplate == template))
+				);
+			});
+
+			// If there is a nearby resource start gathering
+			if (nearby)
+			{
+				this.PerformGather(nearby, false, false);
+				return;
+			}
+
+			// Couldn't find nearby resources, so give up
+			if (this.FinishOrder())
+				return;
+
+			// Nothing better to do: go back to dropsite
+			var nearby = this.FindNearestDropsite(resourceType.generic);
+			if (nearby)
+			{
+				this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
+				return;
+			}
+
+			// No dropsites, just give up
+		},
+	},
+
+	"GATHERING": {
+		"enter": function() {
+			this.gatheringTarget = this.order.data.target;	// deleted in "leave".
+
+			// Check if the resource is full.
+			if (this.gatheringTarget)
+			{
+				// Check that we can gather from the resource we're supposed to gather from.
+				// Will only be added if we're not already in.
+				var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+				var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+				if (!cmpSupply || !cmpSupply.AddGatherer(cmpOwnership.GetOwner(), this.entity))
+				{
+					this.gatheringTarget = INVALID_ENTITY;
+					this.StartTimer(0);
+					return false;
+				}
+			}
+
+			// If this order was forced, the player probably gave it, but now we've reached the target
+			//	switch to an unforced order (can be interrupted by attacks)
+			this.order.data.force = false;
+			this.order.data.autoharvest = true;
+
+			// Calculate timing based on gather rates
+			// This allows the gather rate to control how often we gather, instead of how much.
+			var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+			var rate = cmpResourceGatherer.GetTargetGatherRate(this.gatheringTarget);
+
+			if (!rate)
+			{
+				// Try to find another target if the current one stopped existing
+				if (!Engine.QueryInterface(this.gatheringTarget, IID_Identity))
+				{
+					// Let the Timer logic handle this
+					this.StartTimer(0);
+					return false;
+				}
+
+				// No rate, give up on gathering
+				this.FinishOrder();
+				return true;
+			}
+
+			// Scale timing interval based on rate, and start timer
+			// The offset should be at least as long as the repeat time so we use the same value for both.
+			var offset = 1000/rate;
+			var repeat = offset;
+			this.StartTimer(offset, repeat);
+
+			// We want to start the gather animation as soon as possible,
+			// but only if we're actually at the target and it's still alive
+			// (else it'll look like we're chopping empty air).
+			// (If it's not alive, the Timer handler will deal with sending us
+			// off to a different target.)
+			if (this.CheckTargetRange(this.gatheringTarget, IID_ResourceGatherer))
+			{
+				var typename = "gather_" + this.order.data.type.specific;
+				this.SelectAnimation(typename, false, 1.0, typename);
+			}
+			return false;
+		},
+
+		"leave": function() {
+			this.StopTimer();
+
+			// don't use ownership because this is called after a conversion/resignation
+			// and the ownership would be invalid then.
+			var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+			if (cmpSupply)
+				cmpSupply.RemoveGatherer(this.entity);
+			delete this.gatheringTarget;
+
+			// Show the carried resource, if we've gathered anything.
+			this.SetGathererAnimationOverride();
+		},
+
+		"Timer": function(msg) {
+			var resourceTemplate = this.order.data.template;
+			var resourceType = this.order.data.type;
+
+			var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+			if (!cmpOwnership)
+				return;
+
+			var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
+			if (cmpSupply && cmpSupply.IsAvailable(cmpOwnership.GetOwner(), this.entity))
+			{
+				// Check we can still reach and gather from the target
+				if (this.CheckTargetRange(this.gatheringTarget, IID_ResourceGatherer) && this.CanGather(this.gatheringTarget))
+				{
+					// Gather the resources:
+
+					var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+
+					// Try to gather treasure
+					if (cmpResourceGatherer.TryInstantGather(this.gatheringTarget))
+						return;
+
+					// If we've already got some resources but they're the wrong type,
+					// drop them first to ensure we're only ever carrying one type
+					if (cmpResourceGatherer.IsCarryingAnythingExcept(resourceType.generic))
+						cmpResourceGatherer.DropResources();
+
+					// Collect from the target
+					var status = cmpResourceGatherer.PerformGather(this.gatheringTarget);
+
+					// If we've collected as many resources as possible,
+					// return to the nearest dropsite
+					if (status.filled)
+					{
+						var nearby = this.FindNearestDropsite(resourceType.generic);
+						if (nearby)
+						{
+							// (Keep this Gather order on the stack so we'll
+							// continue gathering after returning)
+							this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
+							return;
+						}
+
+						// Oh no, couldn't find any drop sites. Give up on gathering.
+						this.FinishOrder();
+						return;
+					}
+
+					// We can gather more from this target, do so in the next timer
+					if (!status.exhausted)
+						return;
+				}
+				else
+				{
+					// Try to follow the target
+					if (this.MoveToTargetRange(this.gatheringTarget, IID_ResourceGatherer))
+					{
+						this.SetNextState("APPROACHING");
+						return;
+					}
+
+					// Can't reach the target, or it doesn't exist any more
+
+					// We want to carry on gathering resources in the same area as
+					// the old one. So try to get close to the old resource's
+					// last known position
+
+					var maxRange = 8; // get close but not too close
+					if (this.order.data.lastPos &&
+						this.MoveToPointRange(this.order.data.lastPos.x, this.order.data.lastPos.z,
+							0, maxRange))
+					{
+						this.SetNextState("APPROACHING");
+						return;
+					}
+				}
+			}
+
+			// We're already in range, can't get anywhere near it or the target is exhausted.
+
+			var herdPos = this.order.data.initPos;
+
+			// Give up on this order and try our next queued order
+			if (this.FinishOrder())
+				return;
+
+			// No remaining orders - pick a useful default behaviour
+
+			// Try to find a new resource of the same specific type near our current position:
+			// Also don't switch to a different type of huntable animal
+			var nearby = this.FindNearbyResource(function (ent, type, template) {
+				return (
+					(type.generic == "treasure" && resourceType.generic == "treasure")
+					|| (type.specific == resourceType.specific
+					&& (type.specific != "meat" || resourceTemplate == template))
+				);
+			});
+			if (nearby)
+			{
+				this.PerformGather(nearby, false, false);
+				return;
+			}
+
+			// If hunting, try to go to the initial herd position to see if we are more lucky
+			if (herdPos)
+				this.GatherNearPosition(herdPos.x, herdPos.z, resourceType, resourceTemplate);
+
+			// Nothing else to gather - if we're carrying anything then we should
+			// drop it off, and if not then we might as well head to the dropsite
+			// anyway because that's a nice enough place to congregate and idle
+
+			var nearby = this.FindNearestDropsite(resourceType.generic);
+			if (nearby)
+			{
+				this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
+				return;
+			}
+			
+			// No dropsites - just give up
+		},
+	},
+};
+
+UnitAI.prototype.UnitFsmSpec.INDIVIDUAL.RETURNRESOURCE = {
+	"APPROACHING": {
+		"enter": function () {
+			this.SelectAnimation("move");
+		},
+
+		"MoveCompleted": function() {
+			// Switch back to idle animation to guarantee we won't
+			// get stuck with the carry animation after stopping moving
+			this.SelectAnimation("idle");
+
+			// Check the dropsite is in range and we can return our resource there
+			// (we didn't get stopped before reaching it)
+			if (this.CheckTargetRange(this.order.data.target, IID_ResourceGatherer) && this.CanReturnResource(this.order.data.target, true))
+			{
+				var cmpResourceDropsite = Engine.QueryInterface(this.order.data.target, IID_ResourceDropsite);
+				if (cmpResourceDropsite)
+				{
+					// Dump any resources we can
+					var dropsiteTypes = cmpResourceDropsite.GetTypes();
+
+					var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+					cmpResourceGatherer.CommitResources(dropsiteTypes);
+
+					// Stop showing the carried resource animation.
+					this.SetGathererAnimationOverride();
+
+					// Our next order should always be a Gather,
+					// so just switch back to that order
+					this.FinishOrder();
+					return;
+				}
+			}
+
+			// The dropsite was destroyed, or we couldn't reach it, or ownership changed
+			// Look for a new one.
+
+			var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+			var genericType = cmpResourceGatherer.GetMainCarryingType();
+			var nearby = this.FindNearestDropsite(genericType);
+			if (nearby)
+			{
+				this.FinishOrder();
+				this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
+				return;
+			}
+
+			// Oh no, couldn't find any drop sites. Give up on returning.
+			this.FinishOrder();
+		},
+	},
+};
+
+/**
+ * Returns the entity ID of the nearest resource supply where the given
+ * filter returns true, or undefined if none can be found.
+ * TODO: extend this to exclude resources that already have lots of
+ * gatherers.
+ */
+UnitAI.prototype.FindNearbyResource = function(filter)
+{
+	var range = 64; // TODO: what's a sensible number?
+
+	var playerMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager);
+	// We accept resources owned by Gaia or any player
+	var players = [0];
+	for (var i = 1; i < playerMan.GetNumPlayers(); ++i)
+		players.push(i);
+
+	var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	var cmpRangeManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_RangeManager);
+	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+	var nearby = cmpRangeManager.ExecuteQuery(this.entity, 0, range, players, IID_ResourceSupply);
+	for each (var ent in nearby)
+	{
+		if (!this.CanGather(ent))
+			continue;
+		var cmpResourceSupply = Engine.QueryInterface(ent, IID_ResourceSupply);
+		var type = cmpResourceSupply.GetType();
+		var amount = cmpResourceSupply.GetCurrentAmount();
+		var template = cmpTemplateManager.GetCurrentTemplateName(ent);
+
+		// Remove "resource|" prefix from template names, if present.
+		if (template.indexOf("resource|") != -1)
+			template = template.slice(9);
+
+		if (amount > 0 && cmpResourceSupply.IsAvailable(cmpOwnership.GetOwner(), this.entity) && filter(ent, type, template))
+			return ent;
+	}
+
+	return undefined;
+};
+
+/**
+ * Returns the entity ID of the nearest resource dropsite that accepts
+ * the given type, or undefined if none can be found.
+ */
+UnitAI.prototype.FindNearestDropsite = function(genericType)
+{
+	// Find dropsites owned by this unit's player
+	var players = [];
+	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+	if (cmpOwnership)
+		players = [cmpOwnership.GetOwner()];
+
+	// Ships are unable to reach land dropsites and shouldn't attempt to do so.
+	var excludeLand = Engine.QueryInterface(this.entity, IID_Identity).HasClass("Ship");
+
+	var rangeMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_RangeManager);
+	var nearby = rangeMan.ExecuteQuery(this.entity, 0, -1, players, IID_ResourceDropsite);
+	if (excludeLand)
+	{
+		nearby = nearby.filter( function(e) {
+			return Engine.QueryInterface(e, IID_Identity).HasClass("Naval");
+		});
+	}
+
+	for each (var ent in nearby)
+	{
+		var cmpDropsite = Engine.QueryInterface(ent, IID_ResourceDropsite);
+		if (!cmpDropsite.AcceptsType(genericType))
+			continue;
+
+		return ent;
+	}
+
+	return undefined;
+};
+
+/**
+ * Adds gather order to the queue, forced by the player 
+ * until the target is reached 
+ */
+UnitAI.prototype.Gather = function(target, queued)
+{
+	this.PerformGather(target, queued, true);
+};
+
+/*
+ * Internal function to abstract the force parameter.
+ */
+UnitAI.prototype.PerformGather = function(target, queued, force)
+{
+	if (!this.CanGather(target))
+	{
+		this.WalkToTarget(target, queued);
+		return;
+	}
+
+	// Save the resource type now, so if the resource gets destroyed
+	// before we process the order then we still know what resource
+	// type to look for more of
+	var cmpResourceSupply = Engine.QueryInterface(target, IID_ResourceSupply);
+	var type = cmpResourceSupply.GetType();
+
+	// Also save the target entity's template, so that if it's an animal,
+	// we won't go from hunting slow safe animals to dangerous fast ones
+	var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	var template = cmpTemplateManager.GetCurrentTemplateName(target);
+
+	// Remove "resource|" prefix from template name, if present.
+	if (template.indexOf("resource|") != -1)
+		template = template.slice(9);
+
+	// Remember the position of our target, if any, in case it disappears
+	// later and we want to head to its last known position
+	var lastPos = undefined;
+	var cmpPosition = Engine.QueryInterface(target, IID_Position);
+	if (cmpPosition && cmpPosition.IsInWorld())
+		lastPos = cmpPosition.GetPosition();
+
+	this.AddOrder("Gather", { "target": target, "type": type, "template": template, "lastPos": lastPos, "force": force }, queued);
+};
+
+/**
+ * Adds gather-near-position order to the queue, not forced, so it can be
+ * interrupted by attacks.
+ */
+UnitAI.prototype.GatherNearPosition = function(x, z, type, template, queued)
+{
+	// Remove "resource|" prefix from template name, if present.
+	if (template.indexOf("resource|") != -1)
+		template = template.slice(9);
+
+	this.AddOrder("GatherNearPosition", { "type": type, "template": template, "x": x, "z": z, "force": false }, queued);
+};
+
+/**
+ * Adds return resource order to the queue, forced by the player.
+ */
+UnitAI.prototype.ReturnResource = function(target, queued)
+{
+	if (!this.CanReturnResource(target, true))
+	{
+		this.WalkToTarget(target, queued);
+		return;
+	}
+
+	this.AddOrder("ReturnResource", { "target": target, "force": true }, queued);
+};
+
+UnitAI.prototype.CanGather = function(target)
+{
+	// The target must be a valid resource supply.
+	var cmpResourceSupply = Engine.QueryInterface(target, IID_ResourceSupply);
+	if (!cmpResourceSupply)
+		return false;
+
+	// Formation controllers should always respond to commands
+	// (then the individual units can make up their own minds)
+	if (this.IsFormationController())
+		return true;
+
+	// Verify that we're able to respond to Gather commands
+	var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+	if (!cmpResourceGatherer)
+		return false;
+
+	// Verify that we can gather from this target
+	if (!cmpResourceGatherer.GetTargetGatherRate(target))
+		return false;
+
+	// No need to verify ownership as we should be able to gather from
+	// a target regardless of ownership.
+	// No need to call "cmpResourceSupply.IsAvailable()" either because that
+	// would cause units to walk to full entities instead of choosing another one
+	// nearby to gather from, which is undesirable.
+	return true;
+};
+
+UnitAI.prototype.CanReturnResource = function(target, checkCarriedResource)
+{
+	// Formation controllers should always respond to commands
+	// (then the individual units can make up their own minds)
+	if (this.IsFormationController())
+		return true;
+
+	// Verify that we're able to respond to ReturnResource commands
+	var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
+	if (!cmpResourceGatherer)
+		return false;
+
+	// Verify that the target is a dropsite
+	var cmpResourceDropsite = Engine.QueryInterface(target, IID_ResourceDropsite);
+	if (!cmpResourceDropsite)
+		return false;
+
+	if (checkCarriedResource)
+	{
+		// Verify that we are carrying some resources,
+		// and can return our current resource to this target
+		var type = cmpResourceGatherer.GetMainCarryingType();
+		if (!type || !cmpResourceDropsite.AcceptsType(type))
+			return false;
+	}
+
+	// Verify that the dropsite is owned by this entity's player
+	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+	if (!cmpOwnership || !IsOwnedByPlayer(cmpOwnership.GetOwner(), target))
+		return false;
+
+	return true;
+};
Index: binaries/data/mods/public/simulation/components/_UnitAI.js
===================================================================
--- binaries/data/mods/public/simulation/components/_UnitAI.js	(revision 0)
+++ binaries/data/mods/public/simulation/components/_UnitAI.js	(working copy)
@@ -0,0 +1,2 @@
+UnitAI.prototype.UnitFsm = new FSM(UnitAI.prototype.UnitFsmSpec);
+
